<?php
//error_reporting(0);
// High Score Service Driver
// Written by Justin Aquadro (Retriever II)
// This program may be redistributed without modification only.
//--------------------------------------------------------------

// Change the following lines to match your settings
$SETTINGS['host'] = "localhost";         // Mysql host.  localhost is fine in most cases
$SETTINGS['m_user'] = "mysqluser";          // Mysql user name
$SETTINGS['m_pass'] = "mysqlpass";        // Mysql password
$SETTINGS['m_db'] = "mysqldb";            // Mysql database
$SETTINGS['master_table'] = "hcdata";    // Table to store master list of highscore tables
$SETTINGS['table_prefix'] = "hc_";       // Prefix for highscore tables

// No modifications needed below this line
//---------------------------------------------------------------

function connect () {
	global $SETTINGS;
	
	$connection = @mysql_connect($SETTINGS['host'], $SETTINGS['m_user'], $SETTINGS['m_pass']);
	@mysql_select_db($SETTINGS['m_db'], $connection);
	return $connection;
}

function install () {
	global $SETTINGS;
	
	if (!$connection = connect())
		exit ("Error: Could not connect to database");
	elseif (file_exists("./hclock.lck"))
		exit ("Error: Lock file found, installation prohibited");
	
	mysql_query("CREATE TABLE {$SETTINGS['master_table']} 
				 (id INT NOT NULL AUTO_INCREMENT, app VARCHAR(100) NOT NULL DEFAULT 'application', 
				 app_table VARCHAR(30) NOT NULL, salt VARCHAR(16) NOT NULL, 
				 PRIMARY KEY (id), KEY (app))", $connection);
	
	$handle = fopen("./hclock.lck", "w");
	fclose($handle);
	
	exit ("Driver successfully installed to server.  Future installation locked.");
}

// Remove to prevent further application registrations
function register_app() {
	global $SETTINGS;
	
	if (!$connection = connect())
		exit ("Error: Could not connect to database");
	if (preg_match("/[^a-z_]/", $_POST['app']) || strlen($_POST['app']) > 20 || strlen($_POST['app']) < 1)
		exit ("Invalid Application ID: Application IDs can be composed of 20 or fewer lower case characters or underscore only.");
	
	$salt = generate_salt();
	mysql_query("CREATE TABLE {$SETTINGS['table_prefix']}{$_POST['app']} 
				 (id INT NOT NULL AUTO_INCREMENT, name VARCHAR(20) NOT NULL DEFAULT 'noname', 
				  aux VARCHAR(20) NOT NULL, score INT NOT NULL, PRIMARY KEY (id), KEY (score))", $connection) or
		exit("Error creating table (Allready Exists)");
	mysql_query("INSERT INTO {$SETTINGS['master_table']} (app,app_table,salt) VALUES 
				 ('{$_POST['app']}', '{$SETTINGS['table_prefix']}{$_POST['app']}', '$salt')", $connection) or
		exit("Error updating master table");

	echo "Your Application Identifier: <b>{$_POST['app']}</b><br>
		  Your Passcode: <b>$salt</b><br>
		  Both the Application Identifier and Passcode must be inserted into the appropriate high score events in your application.";
	
	return;
}

function get_table_data($app, $connection) {
	global $SETTINGS;
	
	$result = mysql_query("SELECT * FROM {$SETTINGS['master_table']} WHERE app = '$app'", $connection);
	if (!$row = mysql_fetch_assoc($result))
		return false;
	else
		return $row;
}

function generate_salt() {
	
	$chars = "abcdefghijklmnopqrstuvwxyz";
	$salt = '';
	for ($x=0; $x<16; $x++) {	
		$salt .= $chars{rand(0,25)};
	}
	
	return $salt;
}
	

function hc_send() {
	
	echo "#LISTEN\n";
	$name = addslashes(stripslashes(str_replace('#', '_', $_GET['name'])));
	$aux = addslashes(stripslashes($_GET['aux']));
	$hash = stripslashes($_GET['chk']);
	$connection = connect();
	if (!$connection) 
		exit("#CONNECTFAIL\n#ERROR\n");
				
	if (!$table = get_table_data($_GET['app'], $connection))
		exit("#READFAIL\n#ERROR\n");
	
	if ($hash != md5($_GET['scr'].$table['salt']))
		exit("#BADMD5\n#ERROR\n");
	
	if (!$result = @mysql_query("SELECT * FROM {$table['app_table']} ORDER BY score ASC", $connection))
		exit("#READFAIL\n#ERROR\n");
	if (!@mysql_query("INSERT INTO {$table['app_table']} (name,score,auxilary) VALUES ('$name',{$_GET['scr']},'$aux')", $connection))
		exit("#WRITEFAIL\n#ERROR\n");
	if (@mysql_num_rows($result) >= 21)
		@mysql_query("DELETE FROM {$table['app_table']} ORDER BY score LIMIT 1", $connection);
	
	echo "#OK\n";
	echo "#DISCONNECT\n";
	return;
}

function hc_get() {
	
	echo "#LISTEN\n";
	$connection = connect();
	if (!$connection)
		exit("#CONNECTFAIL\n#ERROR\n");
	
	if (!$table = get_table_data($_GET['app'], $connection))
		exit("#READFAIL\n#ERROR\n");
	
	if (($result = @mysql_query("SELECT * FROM {$table['app_table']} ORDER BY score DESC LIMIT 20", $connection)) === FALSE)
		exit("#READFAIL\n#ERROR\n");
	while ($row = @mysql_fetch_object($result)) {	
		echo "#RECORD\n".$row->name . "##" . "$row->score" . "\n";
	}
	
	echo "#OK\n";
	echo "#DISCONNECT\n";
	return;
}

// Remove to prevent further application registrations
function show_register() {
	echo "<form method='POST' action='{$_SERVER['PHP_SELF']}?act=reg_app'>
		  High Score game registration.  Please chose a unique identifier for your game, 20 characters or fewer, lowercase and underscore characters only.<br>
		  You will recieve a Passcode to use with the identifier you chose.  Please write these two values down, as they need to be inserted into your application.<br>
		  <input type='text' name='app' size='20'> <input type='submit' value='Register'></form>";
	return;
}

switch($_GET['act'])
{
	case 'hcsend': hc_send(); break;
	case 'hcget': hc_get(); break;
	case 'install': install(); break;
	case 'reg_app': register_app(); break;
	case 'show_reg': show_register(); break;
}

?>